#include "raduino_fc.h"
#include "PID_v1.h"

FC Flight(Serial1);

boolean startFlag = false;
boolean startControl = false;

int ledPin = PC13;

//Define Variables we'll be connecting to
double Setpoint, Input, Output;

//double Kp=0.1, Ki=0.3, Kd=0.05;
//double Kp=0.15, Ki=0.3, Kd=0.06; // 안정             250mm
//double Kp=0.15, Ki=0.3, Kd=0.07;   // 안정
//double Kp=0.15, Ki=0.3, Kd=0.08; // 조금 출렁임
//double Kp=0.2, Ki=0.3, Kd=0.08;  // 출렁임

double Kp=0.2, Ki=0.3, Kd=0.07; // 불안정      350mm
//double Kp=0.2, Ki=0.3, Kd=0.08;   // 출렁임
//double Kp=0.2, Ki=0.3, Kd=0.09;  // 안정
//double Kp=0.2, Ki=0.3, Kd=0.10;  // 안정 1
//double Kp=0.2, Ki=0.3, Kd=0.11;   // 안정 2 - 발산

PID myPID(&Input, &Output, &Setpoint, Kp, Ki, Kd, DIRECT);                 //고도, THROTTLE

const int numReadings = 5;
int readings[numReadings];
int readIndex = 0;
int total = 0;
int average = 0;

#define IR_Sensor PA7 // Sharp IR GP2Y0A41SK0F (4-30cm, analog)

int ChannelValue[4];
int G_COUNT = 0;
boolean ledstate =0;
int FailCount = 0;
//--------------------------------------BLYNK----------------------------------------------------//
#define BLYNK_PRINT Serial

#include <BlynkSimpleSerialBLE.h>

char auth[] = "XZ_N06RNm0ZHFO9hNncMJYE0bJ7fMXk5";
//char auth[] = "7zeheoXoZgzdKwqrCsgBP-Jvbpilxu7z";

int yaw = 512;
int thro = 0;
int roll = 512;
int pitch = 512;
double COUNT = 0;
int old_Value[4];

BlynkTimer timer;

void myTimerEvent()
{
  if(startFlag){
    
    if((old_Value[0] == ChannelValue[0])&&(old_Value[1] == ChannelValue[1])&&(old_Value[2] == ChannelValue[2])&&(old_Value[3] == ChannelValue[3]))
    {
      thro = 0; ChannelValue[3]=0;
      Blynk.virtualWrite(V5, 0);
      
    }else
    {
      Blynk.virtualWrite(V5, 1);
    }
    
    for (byte i = 0; i<4; i++) {
      old_Value[i]      = ChannelValue[i];
    }
  }else
  {
    Blynk.virtualWrite(V5, 2);
  }
}

BLYNK_WRITE(V0) {
  int buttonState  = param[0].asInt();
  if(buttonState > 0)   startFlag = true;
  else   startFlag = false;
  Serial.print("startFlag = ");
  Serial.print(startFlag);
}

BLYNK_WRITE(V4) {
  int buttonState  = param[0].asInt();
  if(buttonState > 0)   startControl = true;
  else   startControl = false;
  Serial.print("startControl = ");
  Serial.print(startControl);
}

BLYNK_WRITE(V1) {
  thro = param[0].asInt();
  yaw = param[1].asInt();
  
  ChannelValue[2]=(1023-yaw);
  ChannelValue[3]=thro;
  // Do something with x and y
 // Serial.print("yaw = ");
 // Serial.print(ChannelValue[2]);
 // Serial.print("; thro = ");
 // Serial.println(ChannelValue[3]);
}

BLYNK_WRITE(V2) {
  pitch = param[0].asInt();
  roll = param[1].asInt();

  ChannelValue[0]=(1023-roll);
  ChannelValue[1]=pitch;
  // Do something with x and y
 // Serial.print("roll = ");
 // Serial.print(ChannelValue[0]);
//  Serial.print("; pitch = ");
// Serial.println(ChannelValue[1]);
}

BLYNK_WRITE(V3) {
  thro = param.asInt();

  ChannelValue[0]=(1023-roll);
  ChannelValue[3]=thro;
  //Serial.print("; thro = ");
  //Serial.println(ChannelValue[3]);
}
//--------------------------------------BLYNK----------------------------------------------------//


void setup() {
  //--------------------------------------PID Control----------------------------------------------------//
  //Setpoint 설정
  Setpoint = 200;  // 200cm 고도

  //PID OUTPUT 범위 세팅
  myPID.SetOutputLimits(300, 500);//100,500

  //PID SampleTime 설정
  myPID.SetSampleTime(50);//50ms
  
  //turn the PID on
  myPID.SetMode(AUTOMATIC);
 //--------------------------------------PID Control----------------------------------------------------//  
  // Pause the timer while we're configuring it
  Timer1.pause();  // FC control

  // Set up period
  Timer1.setPeriod(10000); // in 10 microseconds

  // Set up an interrupt on channel 1
  Timer1.setChannel1Mode(TIMER_OUTPUT_COMPARE);
  Timer1.attachCompare1Interrupt(handler_10ms);

  // Refresh the timer's count, prescale, and overflow
  Timer1.refresh();

  // Start the timer counting
  Timer1.resume();

  Flight.begin();

  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, HIGH);

  delay(100);

  // roll positive right
  // pitch positive forward
  //Flight.Trim(20,10); //roll: 0.0 , pith: -5.0
  Serial.println("Triming...");

  delay(5000);
  
  // binding.....
  Flight.Bind();
  Serial.println("binding...");

//     delay(100);
//   Flight.Cali();  
//   Serial.println("Calibration...");
//-----------BLYNK SETUP---------------------------//
  Serial3.begin(115200);
  Blynk.begin(Serial3, auth);
  
  // Setup a function to be called every second
  timer.setInterval(1000L, myTimerEvent);
  
  Serial.println("Waiting for connections...");
  
  ChannelValue[0]=roll;
  ChannelValue[1]=pitch;  
  ChannelValue[2]=yaw;
  ChannelValue[3]=thro;
//-----------BLYNK SETUP---------------------------//  
}



void loop() {
  int ret = Flight.Event();
  if(ret==1)digitalWrite(LED_BUILTIN,LOW); 
  if(ret>0)Serial.println(Flight.retString);
 
 //----------------BLYNK LOOP---------------------// 
  Blynk.run();
  timer.run(); // Initiates BlynkTimer
  
  bool result = Blynk.connected();
  if(result==false)
  {
    startFlag = false;
    ChannelValue[3]=0;
  }
  //--------------BLYNK LOOP------------------------//

  
//---------------적외선 센서값 입력---------------------------------------//
//  average = IRsensor();
//  Input = average;
  
  //Moving average
  total = total - readings[readIndex];
  readings[readIndex] =IRsensor();
  total = total + readings[readIndex];
  readIndex += 1;
  if(readIndex >= numReadings) {
        readIndex = 0;
  }
  average = total/numReadings;
  Input = average;

//---------------------------------------------------------------------//
//  Serial.print(currTime);
//  Serial.print("   |   ");
//  Serial.print(startFlag);
//  Serial.print(" | ");  
//  Serial.print(ChannelValue[0]);  //312 ~1690 우스틱 좌우 roll
//  Serial.print(" | ");
//  Serial.print(ChannelValue[1]); //325 ~1673 좌스틱 좌우 pitch
//  Serial.println(" | ");
//  Serial.print(ChannelValue[3]); //352 ~1698 좌스틱 상하 yaw
//  Serial.print(" | ");
//  Serial.println(Input); // 고도
//  delay(1); 

//  Serial3.println(Input);
//  delay(1); 
}

void handler_10ms(void) {
  //ble_process();
  
  G_COUNT++;
  if(G_COUNT > 100)
  {
    G_COUNT = 0;   
    ledstate = !ledstate;
    if ( startFlag == true ) digitalWrite(ledPin, ledstate);
  }

  int throttle =0;
  
  if((startControl)&&(startFlag ))//DOWN, 고도 PID ON
  {     
      myPID.Compute(); //고도 PID
       
      //throttle= (int)Output+ChannelValue[3];  //고도 , Throttle
      throttle= (int)Output;  //고도 , Throttle
      if(throttle <200) throttle = 200;
      if(throttle >900) throttle = 900;     
  }else
  {
      throttle= ChannelValue[3]; // 조종값 바이패스
  }
  
  if( FailCount > 200)
  {
    throttle = 0;
  }

  if ( (startFlag == true) )Flight.Tx(ChannelValue[0],ChannelValue[1],ChannelValue[2],throttle);
   
}


void blink_led(void)
{
  digitalWrite(LED_BUILTIN,HIGH);
  delay(100);
  digitalWrite(LED_BUILTIN,LOW);
  delay(100);
  digitalWrite(LED_BUILTIN,HIGH);
  delay(100);
  digitalWrite(LED_BUILTIN,LOW);
}

//---------------적외선 센서---------------------------------------//
int Count = 10;
float Distance, SumDistance, AverageDistance = 0;
float Voltage = 0; 

float IRsensor(void){
  for(int i = 0; i < Count; i++) {  // 5v
    Voltage = analogRead(IR_Sensor)*0.0008056640625;  // value from IR_Sensor * (3.3/2^12)
    Distance = 13*pow(Voltage, -1); // worked out from datasheet graph
    SumDistance = SumDistance + Distance;
  }
  AverageDistance =SumDistance/Count * 10; 
  SumDistance = 0;
  if(AverageDistance > 300) AverageDistance = 300;

  return AverageDistance;
}
