#ifndef raduino_sbus_h
#define raduino_sbus_h

#include "Arduino.h"

#define SBUS_FAILSAFE_INACTIVE 0
#define SBUS_FAILSAFE_ACTIVE   1
#define SBUS_STARTBYTE         0x0f
#define SBUS_ENDBYTE           0x00
#define MAX_VALUE              1700
#define CENTER_VALUE           1000
#define MIN_VALUE              300  
#define ROLL                    1
#define YAW                     4
#define THROTTLE                3
#define PITCH                   2

struct TxChannel {
  int channel[19];
  unsigned int value[19];
};

class SBUS {
	public:
		SBUS(HardwareSerial & serial) : _serial (serial) {}
		void begin();
		void begin(bool useTimer);
		void process();
		int getChannel(int channel);
		int getNormalizedChannel(int channel);
		int getFailsafeStatus();
		int getFrameLoss();
		long getGoodFrames();
		long getLostFrames();
		long getDecoderErrorFrames();
		long long getLastTime();
    void setChannel(int channel, unsigned int value);
    void writeChannel(byte *buffers);    
    int tx_channel;
    unsigned int tx_value;
    bool SBUS_OUT; 
    struct TxChannel ch1;
	private:
		HardwareSerial & _serial; 
		//byte buffers[25];

    unsigned int _channels[18];
		int _failsafe;
		long _goodFrames;
		long _lostFrames;
		long _decoderErrorFrames;
		long long _lastGoodFrame;
};

#endif
