#include "raduino_ble.h"
#include <Arduino.h>

void BLE::begin() {

	for (byte i = 0; i<4; i++) {
		bleValue[i]      = 0;
	}
  
  error_count=0;
  
  inputString1 = "";         // a String to hold incoming data
  // reserve 200 bytes for the inputString:
  inputString1.reserve(200);
    
  stringComplete1 = false;  // whether the string is complete
	
	_serial.begin(115200);
}


int BLE::Event() {
   int ret = 0;

   while (_serial.available()) {
    char inChar = (char)_serial.read();
    inputString1 += inChar;
    
    if (inChar == '\n') {
      BleRX = true;
      stringComplete1 = true;      
    }
   }

  if (stringComplete1) {
    // Serial.println(inputString.indexOf("BIND",0));
    int tmp = inputString1.indexOf("BIND",0);
    
    if(inputString1.indexOf("1234",0)>-1)
    //if((inputString1[0] == 'B')&&(inputString1[1] == 'I')&&(inputString1[2] == 'N')&&(inputString1[3] == 'D'))
    {
      ret=1; //ex_bind
    }
    else 
    {
      if(inputString1.length()>8)  ParseData();
      Txlength = String(bleValue[0]).length() + String(bleValue[1]).length()+String(bleValue[2]).length()+String(bleValue[3]).length();
      if(Txlength == blelength)
      {
        ret = 2; //good data
        error_count=0;
      }else
      {
        ret = 3; //wrong data
        error_count++;
      }
    }
    
    // clear the string:    
    inputString1 = "";
    stringComplete1 = false;
  } 
  return ret; 
}

void BLE::ParseData() { 
    inputString1 = inputString1.substring(1,inputString1.length()); 
    int index = inputString1.indexOf('!');  
    bleValue[0] = inputString1.substring(index+1,index+5).toInt(); //roll
    index = inputString1.indexOf('@'); 
    bleValue[1] = inputString1.substring(index+1,index+5).toInt(); //pitch
    index = inputString1.indexOf('#'); 
    bleValue[2] = inputString1.substring(index+1,index+5).toInt(); //yaw
    index = inputString1.indexOf('$'); 
    bleValue[3] = inputString1.substring(index+1,index+5).toInt(); //throttle
    index = inputString1.indexOf('%'); 
    blelength = inputString1.substring(index+1,index+3).toInt(); //length
    index = inputString1.indexOf('&'); 
    blebutton = inputString1.substring(index+1,index+3).toInt(); //button
        
    if ( bleValue[0] == 0 && bleValue[1] == 0 && bleValue[2] == 0 && bleValue[3] == 0 ) 
    {
      error_count++;
    }else
    {
      error_count=0;
    }
}
