
/* Comment this out to disable prints and save space */
#include "raduino_fc.h"
#include <Wire.h>                     // i2C 통신을 위한 라이브러리

FC Flight(Serial1);

boolean startFlag = false;

int FailCount = 0;
int ChannelValue[4];

#define BLYNK_PRINT Serial

#include <BlynkSimpleSerialBLE.h>

char auth[] = "XZ_N06RNm0ZHFO9hNncMJYE0bJ7fMXk5";
//char auth[] = "7zeheoXoZgzdKwqrCsgBP-Jvbpilxu7z";

int yaw = 512;
int thro = 0;
int roll = 512;
int pitch = 512;
double COUNT = 0;
int old_Value[4];

BlynkTimer timer;

void myTimerEvent()
{
  if(startFlag){
    
    if((old_Value[0] == ChannelValue[0])&&(old_Value[1] == ChannelValue[1])&&(old_Value[2] == ChannelValue[2])&&(old_Value[3] == ChannelValue[3]))
    {
      thro = 0; ChannelValue[3]=0;
      Blynk.virtualWrite(V5, 0);
      
    }else
    {
      Blynk.virtualWrite(V5, 1);
    }
    
    for (byte i = 0; i<4; i++) {
      old_Value[i]      = ChannelValue[i];
    }
  }else
  {
    Blynk.virtualWrite(V5, 2);
  }
}

BLYNK_WRITE(V0) {
  int buttonState  = param[0].asInt();
  if(buttonState > 0)   startFlag = true;
  else   startFlag = false;
  Serial.print("buttonState = ");
  Serial.print(buttonState);
}

BLYNK_WRITE(V1) {
  thro = param[0].asInt();
  yaw = param[1].asInt();
  
  ChannelValue[2]=(1023-yaw);
  ChannelValue[3]=thro;
  // Do something with x and y
 // Serial.print("yaw = ");
 // Serial.print(ChannelValue[2]);
 // Serial.print("; thro = ");
 // Serial.println(ChannelValue[3]);
}

BLYNK_WRITE(V2) {
  pitch = param[0].asInt();
  roll = param[1].asInt();

  ChannelValue[0]=(1023-roll);
  ChannelValue[1]=pitch;
  // Do something with x and y
 // Serial.print("roll = ");
 // Serial.print(ChannelValue[0]);
//  Serial.print("; pitch = ");
// Serial.println(ChannelValue[1]);
}

BLYNK_WRITE(V3) {
  thro = param.asInt();

  ChannelValue[0]=(1023-roll);
  ChannelValue[3]=thro;
  //Serial.print("; thro = ");
  //Serial.println(ChannelValue[3]);
}

void setup()
{
  // Debug console
  Serial.begin(115200);
  raduino_ble_init();//라두이노미니 BLE 연결을 초기화

  Serial3.begin(115200);
  Blynk.begin(Serial3, auth);
  
  // Setup a function to be called every second
  timer.setInterval(1000L, myTimerEvent);
  
  Serial.println("Waiting for connections...");
  
  ChannelValue[0]=roll;
  ChannelValue[1]=pitch;  
  ChannelValue[2]=yaw;
  ChannelValue[3]=thro;
  
}

void loop()
{
  int ret = Flight.Event();
  if(ret==1) digitalWrite(LED_BUILTIN,LOW); 
  if(ret>0) Serial.println(Flight.retString);
  Blynk.run();
  timer.run(); // Initiates BlynkTimer
  
  bool result = Blynk.connected();
  if(result==false)
  {
    startFlag = false;
    ChannelValue[3]=0;
  }
}

//*******************************************************************
//*     Initialization                                              *
//*******************************************************************    
void raduino_ble_init() {
  timer_setup();    
  Flight.begin();
    
  pinMode(LED_BUILTIN, OUTPUT);
  digitalWrite(LED_BUILTIN, HIGH);

  delay(100);

  Flight.Mode(1); //hover craft mode
  Serial.println("hover craft mode...");    

  // roll positive right
  // pitch positive forward
  Flight.Trim(0,0); // (roll , pitch)
  Serial.println("Triming...");

  delay(5000);

  
  // binding.....
  Flight.Bind();
  Serial.println("binding...");
}

//*******************************************************************
//*     TIMER                                                       *
//*******************************************************************
void timer_setup(void)
{
  // Pause the timer while we're configuring it
  Timer1.pause();  // for FC control

  // Set up period
  Timer1.setPeriod(10000); // 10 msec

  // Set up an interrupt on channel 1
  Timer1.setChannel1Mode(TIMER_OUTPUT_COMPARE);
  Timer1.attachCompare1Interrupt(timer_handler_flight_out);
  // Refresh the timer's count, prescale, and overflow
  Timer1.refresh();

  // Start the timer counting
  Timer1.resume();
}

//*******************************************************************
//*     FC control timer hanlder , 10msec                           *
//*******************************************************************
void timer_handler_flight_out(void) {
   noInterrupts();  

   if ( (startFlag == true) )
   {
    Flight.Tx(ChannelValue[0],ChannelValue[1],ChannelValue[2],ChannelValue[3]);

    //Serial.print(ChannelValue[0]);
    //Serial.print(";");
    //Serial.print(ChannelValue[1]);
    //Serial.print(";");
    //Serial.print(ChannelValue[2]);
    //Serial.print(";");
    //Serial.println(ChannelValue[3]);
   }
   interrupts(); 
}

//*******************************************************************
//*     BLE Input timer hanlder , 100usec                           *
//*******************************************************************
void blink_led(void)
{
  digitalWrite(LED_BUILTIN,HIGH);
  delay(100);
  digitalWrite(LED_BUILTIN,LOW);
  delay(100);
  digitalWrite(LED_BUILTIN,HIGH);
  delay(100);
  digitalWrite(LED_BUILTIN,LOW);
}
